# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.carrier import Carrier
from verizon.models.carrier_service_plan import CarrierServicePlan
from verizon.models.feature import Feature


class AccountDetails(object):

    """Implementation of the 'accountDetails' model.

    TODO: type model description here.

    Attributes:
        account_name (str): The numeric name of the account, in the format
            "0000123456-00001". Leading zeros must be included.
        account_number (str): The numeric name of the account, in the format
            "0000123456-00001". Leading zeros must be included.
        organization_name (str): user defined name of organization
        is_provisioning_allowed (bool): Flag set to indicate if account
            details can be edited or not. Default is "true".
        carriers (List[Carrier]): TODO: type description here.
        features (List[Feature]): TODO: type description here.
        service_plans (List[CarrierServicePlan]): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_name": 'accountName',
        "account_number": 'accountNumber',
        "organization_name": 'organizationName',
        "is_provisioning_allowed": 'isProvisioningAllowed',
        "carriers": 'carriers',
        "features": 'features',
        "service_plans": 'servicePlans'
    }

    _optionals = [
        'account_name',
        'account_number',
        'organization_name',
        'is_provisioning_allowed',
        'carriers',
        'features',
        'service_plans',
    ]

    def __init__(self,
                 account_name=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 organization_name=APIHelper.SKIP,
                 is_provisioning_allowed=APIHelper.SKIP,
                 carriers=APIHelper.SKIP,
                 features=APIHelper.SKIP,
                 service_plans=APIHelper.SKIP):
        """Constructor for the AccountDetails class"""

        # Initialize members of the class
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if organization_name is not APIHelper.SKIP:
            self.organization_name = organization_name 
        if is_provisioning_allowed is not APIHelper.SKIP:
            self.is_provisioning_allowed = is_provisioning_allowed 
        if carriers is not APIHelper.SKIP:
            self.carriers = carriers 
        if features is not APIHelper.SKIP:
            self.features = features 
        if service_plans is not APIHelper.SKIP:
            self.service_plans = service_plans 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        account_number = dictionary.get("accountNumber") if dictionary.get("accountNumber") else APIHelper.SKIP
        organization_name = dictionary.get("organizationName") if dictionary.get("organizationName") else APIHelper.SKIP
        is_provisioning_allowed = dictionary.get("isProvisioningAllowed") if "isProvisioningAllowed" in dictionary.keys() else APIHelper.SKIP
        carriers = None
        if dictionary.get('carriers') is not None:
            carriers = [Carrier.from_dictionary(x) for x in dictionary.get('carriers')]
        else:
            carriers = APIHelper.SKIP
        features = None
        if dictionary.get('features') is not None:
            features = [Feature.from_dictionary(x) for x in dictionary.get('features')]
        else:
            features = APIHelper.SKIP
        service_plans = None
        if dictionary.get('servicePlans') is not None:
            service_plans = [CarrierServicePlan.from_dictionary(x) for x in dictionary.get('servicePlans')]
        else:
            service_plans = APIHelper.SKIP
        # Return an object of this model
        return cls(account_name,
                   account_number,
                   organization_name,
                   is_provisioning_allowed,
                   carriers,
                   features,
                   service_plans)
